<script setup lang="ts">
////////////////////////////////
// IMPORT
////////////////////////////////

import { useWorkspaceStore } from "@/stores/useWorkspaceStore";

////////////////////////////////
// PROPS
////////////////////////////////

const props = defineProps({
  workspaceLeaveDialog: {
    type: Boolean,
    required: true,
  },
});

////////////////////////////////
// EMITS
////////////////////////////////

const emits = defineEmits(["workspaceLeaveDialog", "hasLeft"]);

////////////////////////////////
// DATA
////////////////////////////////

const workspaceStore = useWorkspaceStore();
const drawer = ref(false);

////////////////////////////////
// WATCH
////////////////////////////////

watch(
  () => props.workspaceLeaveDialog,
  (newValue) => {
    drawer.value = newValue;
  },
);

////////////////////////////////
// METHODS
////////////////////////////////

// The `close()` function is responsible for closing the dialog box and emitting an
// event to notify the parent component that the workspace leave dialog should
// be closed.
function close() {
  emits("workspaceLeaveDialog", false);
}

// The `leaveWorkspace` function is an asynchronous function that is called
// when the user clicks on the "Leave" button in the dialog box.
async function leaveWorkspace() {
  workspaceStore
    .deleteWorkspaceMember(workspaceStore.currentWorkspaceMember.value)
    .then(async (res) => {
      if (res === true) {
        emits("hasLeft", true);
        await workspaceStore.fetchWorkspaces().then(() => {
          navigateTo("/");
        });
      }
      close();
    });
}
</script>

<template>
  <v-dialog
    v-model="drawer"
    width="auto"
    persistent
  >
    <v-card>
      <v-card-title><v-icon>mdi-exit-to-app</v-icon> Leaving the workspace</v-card-title>
      <v-card-text>
        You are about to leave the workspace {{ workspaceStore.currentWorkspace?.name }}. <br>
        Are you sure?
      </v-card-text>
      <v-card-actions class="d-flex flex-row-reverse">
        <v-btn color="error" @click="leaveWorkspace()">
          Leave
        </v-btn>
        <v-btn @click="close()">
          Cancel
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
